!***************************************************
!*
!* Main program
!*
!***************************************************

PROGRAM Test
  
  !* Modules loaded

  USE constants

  USE algebra
  
  USE init

  IMPLICIT NONE

  !* Variables declaration

  REAL(idp), DIMENSION(:,:), ALLOCATABLE :: a
  REAL(idp), DIMENSION(:), ALLOCATABLE   :: x,b

  INTEGER                                :: n

  !* Code

  !** Size of the system

  write(*,*) 'Please supply a size for the linear system?'
  read(*,*) n

  !** Memory allocation

  ALLOCATE(a(n,n))

  ALLOCATE(x(n),b(n))

  !** Itialization of the problem

  call init_Matrix(a)

  call init_RHS(a,b)

  !** Computation of the solution

  call bicgstab(a,x,b)

  !** Comparaison of the solution to the one 
  !** given in the ini module

  call compare_To_Solution(x)

  !** The solution is written in a file

  write(112,10) x

  10 FORMAT(1E14.6)

  !** Memory deallocation

  deallocate(a,x,b)

END PROGRAM Test
